
/* Define on Darwin to activate all library features */
#define _DARWIN_C_SOURCE 1
/* This must be set to 64 on some systems to enable large file support. */
#define _FILE_OFFSET_BITS 64
/* Define on Linux to activate all library features */
#define _GNU_SOURCE 1
/* This must be defined on some systems to enable large file support. */
#define _LARGEFILE_SOURCE 1
/* Define on NetBSD to activate all library features */
#define _NETBSD_SOURCE 1
/* Define to activate features from IEEE Stds 1003.1-2001 */
#ifndef _POSIX_C_SOURCE
#  define _POSIX_C_SOURCE 200112L
#endif
/* Define on FreeBSD to activate all library features */
#define __BSD_VISIBLE 1
#define __XSI_VISIBLE 700
/* Windows: winsock/winsock2 mess */
#define WIN32_LEAN_AND_MEAN
#ifdef _WIN64
   typedef          __int64 Signed;
   typedef unsigned __int64 Unsigned;
#  define SIGNED_MIN LLONG_MIN 
#else
   typedef          long Signed;
   typedef unsigned long Unsigned;
#  define SIGNED_MIN LONG_MIN
#endif

#if !defined(RPY_ASSERT) && !defined(RPY_LL_ASSERT)
#  define NDEBUG
#endif

/* using ShadowStackFrameworkGCTransformer */
#define MALLOC_ZERO_FILLED 1
#include <Python.h>
#include <src/thread.h>
#include <stdlib.h>
#include <src/signals.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <locale.h>
#include <limits.h>
#include <ctype.h>
#include <wchar.h>
#include <langinfo.h>
#include <libintl.h>
#include <time.h>
#include <errno.h>
#include <sys/select.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/resource.h>
#include <sys/timeb.h>
#include <src/stacklet/stacklet.h>
#include <stdio.h>
#include <src/stack.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <utime.h>
#include <signal.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <src/dtoa.h>
#include <src/threadlocal.h>
#include </builddir/build/BUILD/pypy3-2.4.0-src/pypy/module/_codecs/locale.h>
#include <dlfcn.h>
#include <sys/utsname.h>
#include <string.h>
#include <assert.h>
#include <sys/statvfs.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/evp.h>
#include <openssl/ossl_typ.h>
#include <openssl/x509v3.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdint.h>
#include <netpacket/packet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <src/cjkcodecs/multibytecodec.h>
#include <expat.h>
#include <bzlib.h>
#include <semaphore.h>
#include <pwd.h>
#include <zlib.h>
#include </builddir/build/BUILD/pypy3-2.4.0-src/pypy/module/operator/tscmp.h>
#include <ffi.h>
#include <sys/epoll.h>
#include <sys/file.h>
#include <termios.h>
#include <curses.h>
#include <term.h>
#include <stdarg.h>
int get_errno ();
void set_errno (int v);

static void pypy__decay_jit_counters(char *data, double f1, long size) {
    struct rpy_jitcnt { float times[5]; unsigned short subhashes[5]; };
    struct rpy_jitcnt *p = (struct rpy_jitcnt *)data;
    float f = (float)f1;
    long i;
    for (i=0; i<size; i++) {
        p->times[0] *= f;
        p->times[1] *= f;
        p->times[2] *= f;
        p->times[3] *= f;
        p->times[4] *= f;
        ++p;
    }
}

int pypy_macro_wrapper_WCOREDUMP (int status);
int pypy_macro_wrapper_WIFCONTINUED (int status);
int pypy_macro_wrapper_WIFSTOPPED (int status);
int pypy_macro_wrapper_WIFSIGNALED (int status);
int pypy_macro_wrapper_WIFEXITED (int status);
int pypy_macro_wrapper_WEXITSTATUS (int status);
int pypy_macro_wrapper_WSTOPSIG (int status);
int pypy_macro_wrapper_WTERMSIG (int status);
#define PYPY_NO_OP()

#define pypy__is_nonnull_longdouble(x)  ((x) != 0.0)


static float pypy__uint2singlefloat(unsigned int x) {
    float ff;
    assert(sizeof(float) == 4 && sizeof(unsigned int) == 4);
    memcpy(&ff, &x, 4);
    return ff;
}
static unsigned int pypy__singlefloat2uint(float x) {
    unsigned int ii;
    assert(sizeof(float) == 4 && sizeof(unsigned int) == 4);
    memcpy(&ii, &x, 4);
    return ii;
}

#define pypy_GENERAL_NAME_dirn(name) (name->d.dirn)
int _PyPy_SSL_SetupThreads(void);
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>
#include <sys/select.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdint.h>
#include <errno.h>
#include <netpacket/packet.h>
#include <sys/ioctl.h>
#include <net/if.h>

#ifdef AF_NETLINK
#include <linux/netlink.h>
#endif

char ** get_environ ();
void set_environ (char ** v);

static int pypy__arm_int_div(int a, int b) {
    return a/b;
}
static unsigned int pypy__arm_uint_div(unsigned int a, unsigned int b) {
    return a/b;
}
static int pypy__arm_int_mod(int a, int b) {
    return a % b;
}

pid_t _noprof_fork(void);
int _noprof_execve(char *filename, char *argv[], char *envp[]);
int _noprof_execv(char *path, char *argv[]);
#include <Python.h>
PyObject _Py_NoneStruct;
PyObject _Py_TrueStruct;
PyObject _Py_ZeroStruct;
PyObject _Py_NotImplementedStruct;
PyObject _Py_EllipsisObject;
PyDateTime_CAPI* PyDateTimeAPI = NULL;
extern PyTypeObject _PyExc_ArithmeticError;
PyObject* PyExc_ArithmeticError = (PyObject*)&_PyExc_ArithmeticError;
extern PyTypeObject _PyExc_AssertionError;
PyObject* PyExc_AssertionError = (PyObject*)&_PyExc_AssertionError;
extern PyTypeObject _PyExc_AttributeError;
PyObject* PyExc_AttributeError = (PyObject*)&_PyExc_AttributeError;
extern PyTypeObject _PyExc_BaseException;
PyObject* PyExc_BaseException = (PyObject*)&_PyExc_BaseException;
extern PyTypeObject _PyExc_BufferError;
PyObject* PyExc_BufferError = (PyObject*)&_PyExc_BufferError;
extern PyTypeObject _PyExc_BytesWarning;
PyObject* PyExc_BytesWarning = (PyObject*)&_PyExc_BytesWarning;
extern PyTypeObject _PyExc_DeprecationWarning;
PyObject* PyExc_DeprecationWarning = (PyObject*)&_PyExc_DeprecationWarning;
extern PyTypeObject _PyExc_EOFError;
PyObject* PyExc_EOFError = (PyObject*)&_PyExc_EOFError;
extern PyTypeObject _PyExc_EnvironmentError;
PyObject* PyExc_EnvironmentError = (PyObject*)&_PyExc_EnvironmentError;
extern PyTypeObject _PyExc_Exception;
PyObject* PyExc_Exception = (PyObject*)&_PyExc_Exception;
extern PyTypeObject _PyExc_FloatingPointError;
PyObject* PyExc_FloatingPointError = (PyObject*)&_PyExc_FloatingPointError;
extern PyTypeObject _PyExc_FutureWarning;
PyObject* PyExc_FutureWarning = (PyObject*)&_PyExc_FutureWarning;
extern PyTypeObject _PyExc_GeneratorExit;
PyObject* PyExc_GeneratorExit = (PyObject*)&_PyExc_GeneratorExit;
extern PyTypeObject _PyExc_IOError;
PyObject* PyExc_IOError = (PyObject*)&_PyExc_IOError;
extern PyTypeObject _PyExc_ImportError;
PyObject* PyExc_ImportError = (PyObject*)&_PyExc_ImportError;
extern PyTypeObject _PyExc_ImportWarning;
PyObject* PyExc_ImportWarning = (PyObject*)&_PyExc_ImportWarning;
extern PyTypeObject _PyExc_IndentationError;
PyObject* PyExc_IndentationError = (PyObject*)&_PyExc_IndentationError;
extern PyTypeObject _PyExc_IndexError;
PyObject* PyExc_IndexError = (PyObject*)&_PyExc_IndexError;
extern PyTypeObject _PyExc_KeyError;
PyObject* PyExc_KeyError = (PyObject*)&_PyExc_KeyError;
extern PyTypeObject _PyExc_KeyboardInterrupt;
PyObject* PyExc_KeyboardInterrupt = (PyObject*)&_PyExc_KeyboardInterrupt;
extern PyTypeObject _PyExc_LookupError;
PyObject* PyExc_LookupError = (PyObject*)&_PyExc_LookupError;
extern PyTypeObject _PyExc_MemoryError;
PyObject* PyExc_MemoryError = (PyObject*)&_PyExc_MemoryError;
extern PyTypeObject _PyExc_NameError;
PyObject* PyExc_NameError = (PyObject*)&_PyExc_NameError;
extern PyTypeObject _PyExc_NotImplementedError;
PyObject* PyExc_NotImplementedError = (PyObject*)&_PyExc_NotImplementedError;
extern PyTypeObject _PyExc_OSError;
PyObject* PyExc_OSError = (PyObject*)&_PyExc_OSError;
extern PyTypeObject _PyExc_OverflowError;
PyObject* PyExc_OverflowError = (PyObject*)&_PyExc_OverflowError;
extern PyTypeObject _PyExc_PendingDeprecationWarning;
PyObject* PyExc_PendingDeprecationWarning = (PyObject*)&_PyExc_PendingDeprecationWarning;
extern PyTypeObject _PyExc_ReferenceError;
PyObject* PyExc_ReferenceError = (PyObject*)&_PyExc_ReferenceError;
extern PyTypeObject _PyExc_ResourceWarning;
PyObject* PyExc_ResourceWarning = (PyObject*)&_PyExc_ResourceWarning;
extern PyTypeObject _PyExc_RuntimeError;
PyObject* PyExc_RuntimeError = (PyObject*)&_PyExc_RuntimeError;
extern PyTypeObject _PyExc_RuntimeWarning;
PyObject* PyExc_RuntimeWarning = (PyObject*)&_PyExc_RuntimeWarning;
extern PyTypeObject _PyExc_StopIteration;
PyObject* PyExc_StopIteration = (PyObject*)&_PyExc_StopIteration;
extern PyTypeObject _PyExc_SyntaxError;
PyObject* PyExc_SyntaxError = (PyObject*)&_PyExc_SyntaxError;
extern PyTypeObject _PyExc_SyntaxWarning;
PyObject* PyExc_SyntaxWarning = (PyObject*)&_PyExc_SyntaxWarning;
extern PyTypeObject _PyExc_SystemExit;
PyObject* PyExc_SystemExit = (PyObject*)&_PyExc_SystemExit;
extern PyTypeObject _PyExc_SystemError;
PyObject* PyExc_SystemError = (PyObject*)&_PyExc_SystemError;
extern PyTypeObject _PyExc_TabError;
PyObject* PyExc_TabError = (PyObject*)&_PyExc_TabError;
extern PyTypeObject _PyExc_TypeError;
PyObject* PyExc_TypeError = (PyObject*)&_PyExc_TypeError;
extern PyTypeObject _PyExc_UnboundLocalError;
PyObject* PyExc_UnboundLocalError = (PyObject*)&_PyExc_UnboundLocalError;
extern PyTypeObject _PyExc_UnicodeDecodeError;
PyObject* PyExc_UnicodeDecodeError = (PyObject*)&_PyExc_UnicodeDecodeError;
extern PyTypeObject _PyExc_UnicodeEncodeError;
PyObject* PyExc_UnicodeEncodeError = (PyObject*)&_PyExc_UnicodeEncodeError;
extern PyTypeObject _PyExc_UnicodeError;
PyObject* PyExc_UnicodeError = (PyObject*)&_PyExc_UnicodeError;
extern PyTypeObject _PyExc_UnicodeTranslateError;
PyObject* PyExc_UnicodeTranslateError = (PyObject*)&_PyExc_UnicodeTranslateError;
extern PyTypeObject _PyExc_UnicodeWarning;
PyObject* PyExc_UnicodeWarning = (PyObject*)&_PyExc_UnicodeWarning;
extern PyTypeObject _PyExc_UserWarning;
PyObject* PyExc_UserWarning = (PyObject*)&_PyExc_UserWarning;
extern PyTypeObject _PyExc_ValueError;
PyObject* PyExc_ValueError = (PyObject*)&_PyExc_ValueError;
extern PyTypeObject _PyExc_Warning;
PyObject* PyExc_Warning = (PyObject*)&_PyExc_Warning;
extern PyTypeObject _PyExc_ZeroDivisionError;
PyObject* PyExc_ZeroDivisionError = (PyObject*)&_PyExc_ZeroDivisionError;
PyTypeObject PyType_Type;
PyTypeObject PyBytes_Type;
PyTypeObject PyUnicode_Type;
PyTypeObject PyDict_Type;
PyTypeObject PyTuple_Type;
PyTypeObject PyList_Type;
PyTypeObject PySet_Type;
PyTypeObject PyFrozenSet_Type;
PyTypeObject PyBool_Type;
PyTypeObject PyFloat_Type;
PyTypeObject PyLong_Type;
PyTypeObject PyComplex_Type;
PyTypeObject PyByteArray_Type;
PyTypeObject PyMemoryView_Type;
PyTypeObject PyArray_Type;
PyTypeObject PyBaseObject_Type;
PyTypeObject PyNone_Type;
PyTypeObject PyNotImplemented_Type;
PyTypeObject PyCell_Type;
PyTypeObject PyModule_Type;
PyTypeObject PyProperty_Type;
PyTypeObject PySlice_Type;
PyTypeObject PyStaticMethod_Type;
PyTypeObject PyCFunction_Type;
PyTypeObject PyWrapperDescr_Type;
PyTypeObject PyInstanceMethod_Type;
